var ttDefDelay = 500;		// default delay and style for tooltips.
var ttDefStyle = 'tooltip';
var tooltip = null;			// current tooltip node.

function displayToolTip(){
	if(tooltip){
		tooltip.style.display='block';
	   	var onTime=tooltip.getAttribute('ontime');
	   	if(onTime) setTimeout('deleteToolTip()',onTime);		  
	 	}
	}

function deleteToolTip(){
	if(tooltip){
		document.body.removeChild(tooltip);
		tooltip=null;
	  	}
	}

function _ttConstructToolTip(e,target){
		var html = target.getAttribute('tooltip'), tmp;
		if(!html) return;
		if(tooltip) deleteToolTip(e);
		tooltip = document.createElement('DIV');
		document.body.appendChild(tooltip);
		tmp = target.getAttribute('ttclass');
		if(!tmp) tmp=ttDefStyle;
		setClassAttr(tooltip,tmp);
		tmp=target.getAttribute('ttontime');
		if(tmp) tooltip.setAttribute('ontime',tmp);		 
		tmp=target.getAttribute('ttyoffs');
		if(!tmp) tmp = "5";
		tooltip.setAttribute('ttyoffs',tmp);
		//tooltip.appendChild(document.createTextNode(target.getAttribute('tooltip')));
		tooltip.innerHTML = html;
		moveToolTip(e);
		tmp=target.getAttribute('ttdelay');
		if(!tmp) tmp=ttDefDelay;
		setTimeout('displayToolTip()',tmp); 
		}

if(browser!='ie'){
	constructToolTip = function(e){
		var t=e.target;
		if(t.nodeName=='#text') t=t.parentNode;
		_ttConstructToolTip(e,t);
		}
	moveToolTip = function(e){
		if(tooltip){
			var dw=document.width;
			var scrollLeft=e.pageX - e.clientX;
			if(e.clientX < 0.5 * dw){
				tooltip.style.left=(e.pageX + 15) + 'px';
				tooltip.style.right='';
				tooltip.style.marginLeft='';
				tooltip.style.marginRight=(20 - scrollLeft) + 'px';
				}
			else{
				tooltip.style.right=(dw-(e.pageX - 45)) + 'px';
				tooltip.style.left='';
				tooltip.style.marginLeft=(scrollLeft + 20) + 'px';
				tooltip.style.marginRight='';
				}
			tooltip.style.top=(e.pageY+parseInt(tooltip.getAttribute('ttyoffs'))) + 'px';
			}
		}
	initToolTips = function(){
		document.addEventListener('mouseover',constructToolTip,true);
		document.addEventListener('mouseout',deleteToolTip,true);
		document.addEventListener('mousemove',moveToolTip,true);
	  	}
	}
else{
	constructToolTip = function(e){
		_ttConstructToolTip(e,e.srcElement);
		}
	moveToolTip = function(e){
		if(tooltip){
			var dw=document.body.clientWidth, scrollLeft=0, scrollTop=0;
			if(document.documentElement && document.documentElement.scrollTop){
				scrollLeft = document.documentElement.scrollLeft;
				scrollTop = document.documentElement.scrollTop;
				}
			else if (document.body){
				scrollLeft = document.body.scrollLeft;
				scrollTop = document.body.scrollTop;
				}
			if(e.clientX < 0.5 * dw){
				tooltip.style.left=(e.clientX+scrollLeft + 15) + 'px';
				tooltip.style.right=(20 - scrollLeft) + 'px';
				}
			else{
				tooltip.style.right=(dw-(e.clientX-15)) + 'px';
				tooltip.style.left='';
				}
			tooltip.style.top=(e.clientY+scrollTop + parseInt(tooltip.getAttribute('ttyoffs'))) + 'px';
			}
		}
	initToolTips = function(){
		initIEToolTips = function(node){
			if(node.nodeType==1 && node.getAttribute('tooltip')){
				node.attachEvent('onmouseover',constructToolTip);
				node.attachEvent('onmouseout',deleteToolTip);
				node.attachEvent('onmousemove',moveToolTip);
				}
			for(var i=0; i<node.childNodes.length; i++)
				initIEToolTips(node.childNodes[i]);
			}
		initIEToolTips(document.body);
		}
	}
