//code for the 00-00-00 sort code
function RL_SORTCODE(pfx,errorMessage,flags){
	this.pfx = pfx;
	this.errorMessage=errorMessage;
	this.allowEmpty = flags & 1;
	}

RL_SORTCODE.prototype.onload=function(){
	this.form = document.forms[0];
	var D = this.SORTCODE().value+'', s1='', s2='', s3='';
	if(D){
		y = D.substring(0,2);
		m = D.substring(2,4);
		d = D.substring(4,6);
		this.SORTCODE().value='';
		}
	this.SC1().value = s1;
	this.SC2().value = s2;
	this.SC3().value = s3;
	}

RL_SORTCODE.prototype.getObj=function(id){return this.form.elements[this.pfx+id];}
RL_SORTCODE.prototype.SC1=function(){return this.getObj('SC1');}
RL_SORTCODE.prototype.SC2=function(){return this.getObj('SC2');}
RL_SORTCODE.prototype.SC3=function(){return this.getObj('SC3');}
RL_SORTCODE.prototype.SORTCODE=function(){return this.getObj('SORTCODE');}

RL_SORTCODE.prototype.formLevelValidate=function(){
	var s1=this.SC1().value, s2=this.SC2().value, s3=this.SC3().value, v;
	if(this.allowEmpty && s1=='' && s2=='' && s3=='') v = '';
	else{
		if ((s1.length < 2) || (s2.length < 2) || (s3.length < 2))
		{
			return "Invalid sort code. "+this.errorMessage;
		}
		is1=parseInt(s1,10);
		if(!is1 || is1<0 || is1>99) return 'Invalid sort code. '+this.errorMessage;
		is2=parseInt(s2,10);
		if(!is2 || is2<0 || is2>99) return 'Invalid sort code. '+this.errorMessage;
		is3=parseInt(s3,10);
		if(!is3 || is3<0 || is3>99) return 'Invalid sort code. '+this.errorMessage;

		v = s1+"-"+s2+"-"+s3;
		}
	this.SORTCODE().value = v;
	return '';
	}
